/***********************************************************************************************************************
 *
 * blueMarine Semantic - open source media workflow
 * Copyright (C) 2008-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluemarine.tidalwave.it
 * SCM: https://kenai.com/hg/bluemarine~semantic-src
 *
 **********************************************************************************************************************/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.semantic.graph.impl;

//import it.tidalwave.semantic.viewer.action.ApplyTreeLayoutAction;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.swing.Action;
import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;
import org.openide.util.lookup.Lookups;
import org.openide.util.lookup.ProxyLookup;

/**
 *
 * @author fritz
 */
public class ViewerFilterNode extends FilterNode
  {
    public ViewerFilterNode (Node delegate, Object ... extraObjects)
      {
        super(delegate, Children.LEAF /*FIXME*/, new ProxyLookup(delegate.getLookup(), Lookups.fixed(extraObjects)));
      }

    @Override
    public Action[] getActions (boolean arg0)
      {
        final List<Action> actions = new ArrayList<Action>(Arrays.asList(getOriginal().getActions(arg0)));
        // FIXME; this action should not stay in this module
        actions.add(new ApplyTreeLayoutAction(this));
        return actions.toArray(new Action[0]);
      }
  }
